# ngeo constants definitions

### Methods

#### (static) buildStyle(styleDescriptor) → {module:ol/style/Style~StyleLike}

##### Parameters:

Name | Type | Description
--- | --- | ---
`styleDescriptor` | StyleLike | The description of the style

##### Returns:

Type
  module:ol/style/Style~StyleLike

### Type Definitions

#### Circle

##### Type:

- Object

##### Properties:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`fill` | Fill | <optional> |  | Fill style.
`radius` | number |  |  | Circle radius.
`stroke` | Stroke | <optional> |  | Stroke style.
`displacement` | Array.<number> | <optional> | [0,0] | displacement

#### Fill

##### Type:

- Object

##### Properties:

Name | Type | Attributes | Description
--- | --- | --- | ---
`color` | Array.<number> | string | <optional> | The color.

#### LineConfiguration

Configuration object for one profile's line.

##### Type:

- Object

##### Properties:

Name | Type | Attributes | Description
--- | --- | --- | ---
`color` | string | <optional> | Color of the line (hex color string).
`zExtractor` | function |  | Extract the elevation of a point (an item of the elevation data array).

#### ngeoCsvEncoding

File encoding of the CSV file.

##### Type:

- string

#### ngeoCsvExtension

File extension of the CSV file.

##### Type:

- string

#### ngeoCsvIncludeHeader

Whether to include the header in the exported file or not.

##### Type:

- boolean

#### ngeoCsvQuote

Quote character.

##### Type:

- string

#### ngeoCsvSeparator

Separator character.

##### Type:

- string

#### ngeoGeolocationOptions

Options for the geolocation directive.

##### Type:

- Object

##### Properties:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`accuracyFeatureStyle` | StyleLike | <optional> |  | The style to use to sketch the accuracy feature, which is a regular polygon.
`positionFeatureStyle` | StyleLike | <optional> |  | The style to use to sketch the position feature, which is a point.
`zoom` | number | <optional> |  | If set, in addition to recentering the map view at the location, determines the zoom level to set when obtaining a new position
`autoRotate` | boolean | <optional> |  | Autorotate.
`atLoadingTime` | boolean | <optional> | false | Toggle geolocating at loading time if true.

#### ngeoMeasureDecimals

##### Type:

- number

#### ngeoMeasurePrecision

##### Type:

- number

#### ngeoMeasureSpherical

##### Type:

- boolean

#### ngeoNominatimSearchDefaultParams

##### Type:

- Object.<string, string>

#### ngeoOfflineTestUrl

URL of the test page to detect online/offline.

##### Type:

- string

#### ngeoPermalinkOgcserverUrl

URL to the WFS server.

##### Type:

- string

#### ngeoPointfilter

##### Type:

- string

#### ngeoProfileOptions

Options for the profile.

##### Type:

- Object

##### Properties:

Name | Type | Attributes | Description
--- | --- | --- | ---
`linesConfiguration` | Object.<string, LineConfiguration> |  | Configuration object for the profile's
`styleDefs` | string | <optional> | Inline CSS style definition to inject in the SVG.
`poiLabelAngle` | number | <optional> | Inline CSS style definition to inject in the SVG. lines. The key string of each object is used as class for its respective svg line.
`light` | boolean | <optional> | Show a simplified profile when true.
`lightXAxis` | boolean | <optional> | Show a simplified x axis with only both end ticks.

#### ngeoQueryOptions

The options for the query service.

##### Type:

- Object

##### Properties:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`limit` | number | <optional> | 50 | The maximum number of records per request the query service should ask. Note that sources sharing the same URL are combined together in a single request. This limit will still apply to those.
`queryCountFirst` | boolean | <optional> | false | For WFS sources, should the number of features first be requested with `resultType=hits` before requesting the actual features in an seconds request?
`sourceIdsProperty` | string | <optional> | 'querySourceIds' | Defines the name of the layer property that holds the ids of the sources. Use this if you have more than one source bound to a layer.
`tolerance` | number | <optional> | 3 | When issuing an identify feature request at a click position, either a WMS GetFeatureInfo or a WFS GetFeature request will be used. For GetFeature requests a bbox is built around the position. This `tolerance` in pixel determines the minimal size of the bbox.
`toleranceTouch` | number | <optional> | 10 | Same as `tolerance` but for touch devices.
`featureNS` | string | <optional> | 'http://mapserver.gis.umn.edu/mapserver' | The feature namespace for WFS GetFeature requests.
`featurePrefix` | string | <optional> | 'feature' | The feature prefix for WFS GetFeature requests.
`geometryName` | string | <optional> | 'geom' | The name of the geometry property for WFS GetFeature requests.
`cursorHover` | boolean | <optional> |  |
`bboxAsGETParam` | boolean | <optional> | false | Pass the queried bbox as a parameter of the GET query on WFS requests.

#### ngeoRoutingOptions

##### Type:

- Object

##### Properties:

Name | Type | Attributes | Description
--- | --- | --- | ---
`backendUrl` | string | <optional> |
`profiles` | Array.<RoutingProfile> | <optional> |

#### ngeoScaleSelectorOptions

The scale selector options

##### Type:

- Object

##### Properties:

Name | Type | Attributes | Description
--- | --- | --- | ---
`values` | Array.<number> |  | The available scales
`dropup` | boolean | <optional> | True to get a drop menu that opens imself to the top, instead of the bottom.

#### ngeoSnappingTolerance

##### Type:

- number

#### ngeoStreetviewOptions

Configuration object for streetview.

##### Type:

- Object

##### Properties:

Name | Type | Description
--- | --- | ---
`viewer` | string | The viewer to use (google or mapillary)
`key` | string | ClientId for Mapillary

#### ngeoStringToHtmlReplacements

List of replacements for string to html.

##### Type:

- Array.<StringToHtmlReplacement>

#### ngeoTilesPreloadingLimit

Load tiles up to preload levels. By default preload is Infinity, which means load all tiles on the top of the visible level. See also preload value in documentation for ol.Layer.Tile.

##### Type:

- number

#### ngeoUsedKeyRegexp

Regexp used to identify the used keys.

##### Type:

- Array.<string>

#### ngeoWfsPermalinkOptions

The options for the WFS query service (permalink).

##### Type:

- Object

##### Properties:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`wfsTypes` | Array.<WfsType> |  |  | The queryable WFS types.
`pointRecenterZoom` | number | <optional> |  | Zoom level to use when result is a single point feature. If not set the map is not zoomed to a specific zoom level.
`maxFeatures` | number | <optional> | 50 | The maximum number of records per request the query service should ask.
`defaultFeatureNS` | string |  |  |
`defaultFeaturePrefix` | string |  |  |

#### RegularShape

Specify radius for regular polygons, or radius1 and radius2 for stars. See also: https://openlayers.org/en/latest/examples/regularshape.html

##### Type:

- Object

##### Properties:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`fill` | Fill | <optional> |  | Fill style.
`points` | number |  |  | Number of points for stars and regular polygons. In case of a polygon, the number of points is the number of sides.
`radius` | number | <optional> |  | Radius of a regular polygon.
`radius1` | number | <optional> |  | Outer radius of a star.
`radius2` | number | <optional> |  | Inner radius of a star.
`angle` | number | <optional> | 0 | Shape's angle in radians. A value of 0 will have one of the shape's point facing up.
`displacement` | Array.<number> | <optional> | [0,0] | Displacement of the shape
`stroke` | Stroke | <optional> |  | Stroke style.
`rotation` | number | <optional> | 0 | Rotation in radians (positive rotation clockwise).
`rotateWithView` | boolean | <optional> | false | Whether to rotate the shape with the view.

#### RoutingProfile

##### Type:

- Object

##### Properties:

Name | Type | Description
--- | --- | ---
`label` | string |
`profile` | string |

#### StringToHtmlReplacement

##### Type:

- Object

##### Properties:

Name | Type | Attributes | Description
--- | --- | --- | ---
`expression` | string |  | The regexp expression that must match to do the replacement.
`flags` | string | <optional> | The regexp flags.
`compiled_expression` | RegExp | <optional> | Internal: the compiled regular expression.
`template` | string |  | The template to use to create a new value as replacement if the regex matches.

#### Stroke

##### Type:

- Object

##### Properties:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`color` | Array.<number> | string | <optional> |  | The color.
`lineCap` | CanvasLineCap | <optional> | 'round' | Line cap style: `butt`, `round`, or `square`.
`lineJoin` | CanvasLineJoin | <optional> | 'round' | Line join style: `bevel`, `round`, or `miter`.
`lineDash` | Array.<number> | <optional> |  | Line dash pattern. Default is `null` (no dash). Please note that Internet Explorer 10 and lower do not support the `setLineDash` method on the `CanvasRenderingContext2D` and therefore this option will have no visual effect in these browsers.
`lineDashOffset` | number | <optional> | 0 | Line dash offset.
`miterLimit` | number | <optional> | 10 | Miter limit.
`width` | number | <optional> |  | Width.

#### Style

The style description.

##### Type:

- Object

##### Properties:

Name | Type | Attributes | Description
--- | --- | --- | ---
`fill` | Fill | <optional> | The fill color.
`stroke` | Stroke | <optional> | The stoke config.
`circle` | Circle | <optional> | The circle config.
`regularShape` | RegularShape | <optional> | The regular shape config.
`zIndex` | number | <optional> | The z index.

#### StyleLike

##### Type:

- module:ol/style/Style~StyleLike | Array.<Style> | Style

#### WfsType

A WFS type. To be used with WfsPermalinkOptions.

##### Type:

- Object

##### Properties:

Name | Type | Attributes | Description
--- | --- | --- | ---
`featureType` | string |  | The feature type name. Required.
`label` | string | <optional> | The field of a feature used as label.
`featureNS` | string | <optional> | The namespace URI used for features. If not given, the default namespace set in WfsPermalinkOptions will be used.
`featurePrefix` | string | <optional> | The prefix for the feature namespace. If not given, the default prefix set in WfsPermalinkOptions will be used.
`defaultFeatureNS` | string | <optional> | The default namespace URI used for features. This will be used if no custom namespace is given for a WFS type.
`defaultFeaturePrefix` | string | <optional> | The default prefix for the feature namespace. This will be used if no custom prefix is given for a WFS type.